#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <windows.h>

typedef struct _cvor
{
	int v;
	struct _cvor *s;
	struct _cvor *p;
}cvor;

void greska(char *s)
{
	fprintf(stderr, "greska: %s\n", s);
	exit(EXIT_FAILURE);
}

cvor *kreiraj_cvor(int v)
{
	cvor *novi = malloc(sizeof(cvor));
	if(novi == NULL)
		greska("malloc");
	
	novi->v = v;
	novi->s = NULL;
	novi->p = NULL;
	return novi;
}

cvor *dodaj_na_pocetak(cvor *g, int v)
{
	if(g == NULL)
		return kreiraj_cvor(v);
	
	cvor *ng = kreiraj_cvor(v);
	ng->s = g;
	g->p = ng;
	
	return ng;
}

cvor *ucitaj_listu()
{
	cvor *lista = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
		
		lista = dodaj_na_pocetak(lista, x);
	}
	
	return lista;
}

void ispis(cvor *g)
{
	if(g == NULL)
	{
		printf("\n");
		return;
	}
	
	printf("%d ", g->v);
	ispis(g->s);
}

cvor *oslobodi(cvor *g)
{
	if(g == NULL)
		return NULL;	
	
	cvor *sl = g->s;	
	free(g);
	return oslobodi(sl);
}

cvor* obrni_svaka_dva(cvor *l)
{
	//l = 1 2 3 4
	//l = NULL <-> 1 <-> 2 <-> 3 <-> 4 <-> NULL
	//l = 1
	//a = NULL;
	//b = 1;
	//c = 2;
	//d = 3;
	if(l == NULL)
		return NULL;
	if(l->s == NULL)
		return l;
		
	//ovde sigurno znamo da postoje l i l->s
	//a ne znamo da li postoje l->p, l->s->s
	
	//posto postoje l i l->s, mozemo da radimo obrtanje
	
	//da smo pozvali rekurziju pre obrtanja cvorova
	//c->s = obrni_svaka_dva(d);
	
	cvor *a = l->p;
	cvor *b = l;
	cvor *c = l->s;
	cvor *d = l->s->s;
	
	c->p = a;
	c->s = b;
	b->p = c;
	b->s = d;
	if(a != NULL)
		a->s = c;
	if(d != NULL)
		d->p = b;
		
	b->s = obrni_svaka_dva(d);
	return c;
	
}

int main()
{
	cvor *l = ucitaj_listu();
	ispis(l);
	
	l = obrni_svaka_dva(l);
	ispis(l);
	
	l = oslobodi(l);
	return 0;
}