#include <stdio.h>
#include <stdlib.h>

typedef struct _cvor
{
	int v;
	struct _cvor *s;
}cvor;

void greska(char *s)
{
	fprintf(stderr, "greska: %s\n", s);
	exit(EXIT_FAILURE);
}

cvor *kreiraj_cvor(int v)
{
	cvor *novi = malloc(sizeof(cvor));
	if(novi == NULL)
		greska("malloc");
	
	novi->v = v;
	novi->s = NULL;
	return novi;
}

cvor *zadnji(cvor *g)
{
	if(g == NULL)
		return NULL;
	cvor *temp = g;
	
	while(temp->s != g)
	{
		temp = temp->s;
	}
	return temp;
}

cvor *dodaj_na_pocetak(cvor *g, int v)
{
	if(g == NULL)
	{
		cvor *novi = kreiraj_cvor(v);
		novi->s = novi;
		return novi;
	}
	else
	{
		cvor *z = zadnji(g);
		cvor *novi = kreiraj_cvor(v);
		z->s = novi;
		novi->s = g;
		return novi;
	}
}

cvor *ucitaj_listu()
{
	cvor *lista = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
		
		lista = dodaj_na_pocetak(lista, x);
	}
	
	return lista;
}

void ispis(cvor *g)
{
	cvor *tmp = g->s;
	printf("%d ", g->v);
	while(tmp != g)
	{
		printf("%d ", tmp->v);
		tmp = tmp->s;
	}
	printf("\n");
}

int main()
{
	cvor *kl = ucitaj_listu();
	ispis(kl);
	
	int k;
	scanf("%d", &k);
	while(kl != NULL)
	{
		int i;
		//krecemo se za k mesta u krug
		for(i = 0; i < k; i++)
			kl = kl->s;
		
		printf("dete koje se izbacuje je %d\n", kl->v);
		
		//treba izbaciti cvor kl
		cvor *p = zadnji(kl);
		cvor *s = kl->s;
		
		if(p == kl)
		{
			//to znaci da je kl jedini element
			free(kl);
			kl = NULL;
		}
		else
		{
			//ima vise elemenata u listi i radimo redirekciju, odnosno preskacemo kl
			free(kl);
			p->s = s;
			kl = s;
		}
	}
	return 0;
}
