#include <stdio.h>
#include <stdlib.h>

typedef struct _cvor
{
	int v;
	struct _cvor *p;
	struct _cvor *s;
}cvor;

void greska(char *s)
{
	fprintf(stderr, "Greska: %s\n", s);
	exit(EXIT_FAILURE);
}

cvor* kreiraj_cvor(int v)
{
	cvor *novi = malloc(sizeof(cvor));
	if(novi == NULL)
		greska("alokacija");
	novi->v = v;
	novi->s = NULL;
	novi->p = NULL;
}

cvor* dodaj_na_pocetak(cvor *g, int v)
{
	if(g == NULL)
		return kreiraj_cvor(v);
		
	cvor *novi = kreiraj_cvor(v);
	novi->s = g;
	g->p = novi;
	return novi;
}

cvor *ucitaj_listu()
{
	cvor *l = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
			
		l = dodaj_na_pocetak(l, x);
	}
	return l;
}

void ispis(cvor *g)
{
	if(g == NULL)
		printf("\n");
	else
	{
		printf("%d ", g->v);
		ispis(g->s);
	}
}

cvor *oslobodi(cvor *g)
{
	if(g == NULL)
		return NULL;
	
	cvor *s = g->s;
	free(g);
	return oslobodi(s);
}

cvor* obrni_svaka_dva(cvor *g)
{
	if(g == NULL)
		return NULL;
	if(g->s == NULL)
		return g;
	
	//ovde sigurno znamo da imamo 2 elementa
	//g i g->s
	
	//1 2 3 4 5 6
	//1 2 -> obrni_svaka_dva(3 4 5 6)
	//1 2 4 3 6 5
	g->s->s = obrni_svaka_dva(g->s->s);
	
	//kada smo obrnuli ostatak
	//ovde treba da okrenemo samo prva 2
	cvor *a = g->p;
	cvor *b = g;
	cvor *c = g->s;
	cvor *d = g->s->s;
	
	b->s = d;
	b->p = c;
	c->s = b;
	c->p = a;
	if(a != NULL) a->s = c;
	if(d != NULL) d->p = b;
	
	return c;
}

int main()
{
	cvor *l = ucitaj_listu();
	ispis(l);
	
	l = obrni_svaka_dva(l);
	ispis(l);
	l = oslobodi(l);
}