#include <stdio.h>
#include <stdlib.h>

typedef struct _cvor
{
	int v;
	struct _cvor *s;
}cvor;

void greska(char *s)
{
	fprintf(stderr, "Greska: %s\n", s);
	exit(EXIT_FAILURE);
}

cvor* kreiraj_cvor(int v)
{
	cvor *c = malloc(sizeof(cvor));
	if(c == NULL)
		greska("alokacija");
	c->v = v;
	c->s = NULL;
	return c;
}

cvor *poslednji(cvor *g)
{
	if(g == NULL)
		return NULL;
	
	cvor *zadnji = g;
	while(zadnji->s != g)
		zadnji = zadnji->s;
	return zadnji;
}

cvor* dodaj_na_kraj_liste(cvor *g, int v)
{
	if(g == NULL)
	{
		cvor *novi = kreiraj_cvor(v);
		novi->s = novi;
		return novi;
	}
	else
	{
		//1 2 3 4 5 1, a dodajemo 6
		//1 2 3 4 5 [6] 1
		//znaci treba nam el. 5 i el 1.
		//odnosno da bi smo ubacili novi trebaju nam 
		//glava liste i poslednji element u listi
		
		cvor *z = poslednji(g);
		cvor *novi = kreiraj_cvor(v);
		
		z->s = novi;
		novi->s = g;
		return g;
	}
}

cvor *ucitaj_listu()
{
	cvor *l = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
			
		l = dodaj_na_kraj_liste(l, x);
	}
	return l;
}
cvor* izbaci_trenutni(cvor *g)
{
	if(g == NULL)
		return NULL;
	
	if(g->s == g)
	{
		free(g);
		return NULL;
	}
	
	cvor *z = poslednji(g);
	cvor *s = g->s;
	free(g);
	z->s = s;
	return z;
}
int main()
{
	cvor *l = ucitaj_listu();
	int k;
	printf("unesite k: ");
	scanf("%d", &k);
	
	while(l != NULL)
	{
		//prvo idemo do k-tog deteta
		int i;
		for(i = 0; i < k; i++)
			l = l->s;
		
		printf("sledece je dete: %d\n", l->v);
		l = izbaci_trenutni(l);
	}
	return 0;
}